diff --git a/drupal7/sites/all/modules/media/js/media.popups.js b/drupal7/sites/all/modules/media/js/media.popups.js
index 95b72e3f..2abb96e6 100644
--- a/drupal7/sites/all/modules/media/js/media.popups.js
+++ b/drupal7/sites/all/modules/media/js/media.popups.js
@@ -58,17 +58,15 @@ Drupal.media.popups.mediaBrowser = function (onSelect, globalOptions, pluginOpti
   var mediaIframe = Drupal.media.popups.getPopupIframe(browserSrc, 'mediaBrowser');
   // Attach the onLoad event
   mediaIframe.bind('load', options, options.widget.onLoad);
+
   /**
    * Setting up the modal dialog
    */
-
   var ok = 'OK';
-  var cancel = 'Cancel';
   var notSelected = 'You have not selected anything!';
 
   if (Drupal && Drupal.t) {
     ok = Drupal.t(ok);
-    cancel = Drupal.t(cancel);
     notSelected = Drupal.t(notSelected);
   }
 
@@ -85,14 +83,13 @@ Drupal.media.popups.mediaBrowser = function (onSelect, globalOptions, pluginOpti
     $(this).dialog("close");
   };
 
-  dialogOptions.buttons[cancel] = function () {
-    $(this).dialog("close");
-  };
+  var dialog = mediaIframe.dialog(dialogOptions);
+
+  Drupal.media.popups.sizeDialog(dialog);
+  Drupal.media.popups.resizeDialog(dialog);
+  Drupal.media.popups.scrollDialog(dialog);
+  Drupal.media.popups.overlayDisplace(dialog.parents(".ui-dialog"));
 
-  Drupal.media.popups.setDialogPadding(mediaIframe.dialog(dialogOptions));
-  // Remove the title bar.
-  mediaIframe.parents(".ui-dialog").find(".ui-dialog-titlebar").remove();
-  Drupal.media.popups.overlayDisplace(mediaIframe.parents(".ui-dialog"));
   return mediaIframe;
 };
 
@@ -149,7 +146,14 @@ Drupal.media.popups.mediaBrowser.finalizeSelection = function () {
 Drupal.media.popups.mediaStyleSelector = function (mediaFile, onSelect, options) {
   var defaults = Drupal.media.popups.mediaStyleSelector.getDefaults();
   // @todo: remove this awful hack :(
-  defaults.src = defaults.src.replace('-media_id-', mediaFile.fid) + '&fields=' + JSON.stringify(mediaFile.fields);
+  if (typeof defaults.src === 'string' ) {
+    defaults.src = defaults.src.replace('-media_id-', mediaFile.fid) + '&fields=' + encodeURIComponent(JSON.stringify(mediaFile.fields));
+  }
+  else {
+    var src = defaults.src.shift();
+    defaults.src.unshift(src);
+    defaults.src = src.replace('-media_id-', mediaFile.fid) + '&fields=' + encodeURIComponent(JSON.stringify(mediaFile.fields));
+  }
   options = $.extend({}, defaults, options);
   // Create it as a modal window.
   var mediaIframe = Drupal.media.popups.getPopupIframe(options.src, 'mediaStyleSelector');
@@ -160,12 +164,10 @@ Drupal.media.popups.mediaStyleSelector = function (mediaFile, onSelect, options)
    * Set up the button text
    */
   var ok = 'OK';
-  var cancel = 'Cancel';
   var notSelected = 'Very sorry, there was an unknown error embedding media.';
 
   if (Drupal && Drupal.t) {
     ok = Drupal.t(ok);
-    cancel = Drupal.t(cancel);
     notSelected = Drupal.t(notSelected);
   }
 
@@ -183,14 +185,13 @@ Drupal.media.popups.mediaStyleSelector = function (mediaFile, onSelect, options)
     $(this).dialog("close");
   };
 
-  dialogOptions.buttons[cancel] = function () {
-    $(this).dialog("close");
-  };
+  var dialog = mediaIframe.dialog(dialogOptions);
+
+  Drupal.media.popups.sizeDialog(dialog);
+  Drupal.media.popups.resizeDialog(dialog);
+  Drupal.media.popups.scrollDialog(dialog);
+  Drupal.media.popups.overlayDisplace(dialog.parents(".ui-dialog"));
 
-  Drupal.media.popups.setDialogPadding(mediaIframe.dialog(dialogOptions));
-  // Remove the title bar.
-  mediaIframe.parents(".ui-dialog").find(".ui-dialog-titlebar").remove();
-  Drupal.media.popups.overlayDisplace(mediaIframe.parents(".ui-dialog"));
   return mediaIframe;
 };
 
@@ -235,12 +236,10 @@ Drupal.media.popups.mediaFieldEditor = function (fid, onSelect, options) {
    * Set up the button text
    */
   var ok = 'OK';
-  var cancel = 'Cancel';
   var notSelected = 'Very sorry, there was an unknown error embedding media.';
 
   if (Drupal && Drupal.t) {
     ok = Drupal.t(ok);
-    cancel = Drupal.t(cancel);
     notSelected = Drupal.t(notSelected);
   }
 
@@ -257,14 +256,13 @@ Drupal.media.popups.mediaFieldEditor = function (fid, onSelect, options) {
     $(this).dialog("close");
   };
 
-  dialogOptions.buttons[cancel] = function () {
-    $(this).dialog("close");
-  };
+  var dialog = mediaIframe.dialog(dialogOptions);
+
+  Drupal.media.popups.sizeDialog(dialog);
+  Drupal.media.popups.resizeDialog(dialog);
+  Drupal.media.popups.scrollDialog(dialog);
+  Drupal.media.popups.overlayDisplace(dialog);
 
-  Drupal.media.popups.setDialogPadding(mediaIframe.dialog(dialogOptions));
-  // Remove the title bar.
-  mediaIframe.parents(".ui-dialog").find(".ui-dialog-titlebar").remove();
-  Drupal.media.popups.overlayDisplace(mediaIframe.parents(".ui-dialog"));
   return mediaIframe;
 };
 
@@ -291,49 +289,30 @@ Drupal.media.popups.mediaFieldEditor.getDefaults = function () {
 Drupal.media.popups.getDialogOptions = function () {
   return {
     buttons: {},
-    dialogClass: 'media-wrapper',
-    modal: true,
-    draggable: false,
-    resizable: false,
-    minWidth: 500,
-    width: 670,
-    height: 280,
-    position: 'center',
+    dialogClass: Drupal.settings.media.dialogOptions.dialogclass,
+    modal: Drupal.settings.media.dialogOptions.modal,
+    draggable: Drupal.settings.media.dialogOptions.draggable,
+    resizable: Drupal.settings.media.dialogOptions.resizable,
+    minWidth: Drupal.settings.media.dialogOptions.minwidth,
+    width: Drupal.settings.media.dialogOptions.width,
+    height: Drupal.settings.media.dialogOptions.height,
+    position: Drupal.settings.media.dialogOptions.position,
     overlay: {
-      backgroundColor: '#000000',
-      opacity: 0.4
+      backgroundColor: Drupal.settings.media.dialogOptions.overlay.backgroundcolor,
+      opacity: Drupal.settings.media.dialogOptions.overlay.opacity
     },
-    zIndex: 10000,
+    zIndex: Drupal.settings.media.dialogOptions.zindex,
     close: function (event, ui) {
       $(event.target).remove();
     }
   };
 };
 
-/**
- * Created padding on a dialog
- *
- * @param jQuery dialogElement
- *  The element which has .dialog() attached to it.
- */
-Drupal.media.popups.setDialogPadding = function (dialogElement) {
-  // @TODO: Perhaps remove this hardcoded reference to height.
-  // - It's included to make IE on Windows 7 display the dialog without
-  //   collapsing. 550 is the height that displays all of the tab panes
-  //   within the Add Media overlay. This is either a bug in the jQuery
-  //   UI library, a bug in IE on Windows 7 or a bug in the way the
-  //   dialog is instantiated. Or a combo of the three.
-  //   All browsers except IE on Win7 ignore these defaults and adjust
-  //   the height of the iframe correctly to match the content in the panes
-  dialogElement.height(dialogElement.dialog('option', 'height'));
-  dialogElement.width(dialogElement.dialog('option', 'width'));
-};
-
 /**
  * Get an iframe to serve as the dialog's contents. Common to both plugins.
  */
 Drupal.media.popups.getPopupIframe = function (src, id, options) {
-  var defaults = {width: '800px', scrolling: 'auto'};
+  var defaults = {width: '100%', scrolling: 'auto'};
   var options = $.extend({}, defaults, options);
 
   return $('<iframe class="media-modal-frame"/>')
@@ -352,4 +331,54 @@ Drupal.media.popups.overlayDisplace = function (dialog) {
   }
 }
 
+/**
+ * Size the dialog when it is first loaded and keep it centered when scrolling.
+ *
+ * @param jQuery dialogElement
+ *  The element which has .dialog() attached to it.
+ */
+Drupal.media.popups.sizeDialog = function (dialogElement) {
+  if (!dialogElement.is(':visible')) {
+    return;
+  }
+  var windowWidth = $(window).width();
+  var dialogWidth = windowWidth * 0.8;
+  var windowHeight = $(window).height();
+  var dialogHeight = windowHeight * 0.8;
+
+  dialogElement.dialog("option", "width", dialogWidth);
+  dialogElement.dialog("option", "height", dialogHeight);
+  dialogElement.dialog("option", "position", 'center');
+
+  $('.media-modal-frame').width('100%');
+}
+
+/**
+ * Resize the dialog when the window changes.
+ *
+ * @param jQuery dialogElement
+ *  The element which has .dialog() attached to it.
+ */
+Drupal.media.popups.resizeDialog = function (dialogElement) {
+  $(window).resize(function() {
+    Drupal.media.popups.sizeDialog(dialogElement);
+  });
+}
+
+/**
+ * Keeps the dialog centered when the window is scrolled.
+ *
+ * @param jQuery dialogElement
+ *  The element which has .dialog() attached to it.
+ */
+Drupal.media.popups.scrollDialog = function (dialogElement) {
+  // Keep the dialog window centered when scrolling.
+  $(window).scroll(function() {
+    if (!dialogElement.is(':visible')) {
+      return;
+    }
+    dialogElement.dialog("option", "position", 'center');
+  });
+}
+
 })(jQuery);
diff --git a/drupal7/sites/all/modules/media/media.file_default_displays.inc b/drupal7/sites/all/modules/media/media.file_default_displays.inc
new file mode 100644
index 00000000..ec7a378f
--- /dev/null
+++ b/drupal7/sites/all/modules/media/media.file_default_displays.inc
@@ -0,0 +1,61 @@
+<?php
+
+/**
+ * @file
+ * Default display configuration for the default file types.
+ */
+
+/**
+ * Implements hook_file_default_displays().
+ */
+function media_file_default_displays() {
+  $file_displays = array();
+
+  // Audio previews should be displayed using a large filetype icon.
+  $file_display = new stdClass();
+  $file_display->api_version = 1;
+  $file_display->name = 'audio__preview__file_field_media_large_icon';
+  $file_display->weight = 50;
+  $file_display->status = TRUE;
+  $file_display->settings = '';
+  $file_displays['audio__preview__file_field_media_large_icon'] = $file_display;
+
+  // Document previews should be displayed using a large filetype icon.
+  $file_display = new stdClass();
+  $file_display->api_version = 1;
+  $file_display->name = 'document__preview__file_field_media_large_icon';
+  $file_display->weight = 50;
+  $file_display->status = TRUE;
+  $file_display->settings = '';
+  $file_displays['document__preview__file_field_media_large_icon'] = $file_display;
+
+  // Image previews should be displayed using a large filetype icon.
+  $file_display = new stdClass();
+  $file_display->api_version = 1;
+  $file_display->name = 'image__preview__file_field_media_large_icon';
+  $file_display->weight = 50;
+  $file_display->status = TRUE;
+  $file_display->settings = '';
+  $file_displays['image__preview__file_field_media_large_icon'] = $file_display;
+
+  // Video previews should be displayed using a large filetype icon.
+  $file_display = new stdClass();
+  $file_display->api_version = 1;
+  $file_display->name = 'video__preview__file_field_media_large_icon';
+  $file_display->weight = 50;
+  $file_display->status = TRUE;
+  $file_display->settings = '';
+  $file_displays['video__preview__file_field_media_large_icon'] = $file_display;
+
+  return $file_displays;
+}
+
+/**
+ * Implements hook_file_default_displays_alter().
+ */
+function media_file_default_displays_alter(&$file_displays) {
+  // Image previews should be displayed using the media image style.
+  if (isset($file_displays['image__preview__file_field_image'])) {
+    $file_displays['image__preview__file_field_image']->settings['image_style'] = 'media_thumbnail';
+  }
+}
diff --git a/drupal7/sites/all/modules/media/media.info b/drupal7/sites/all/modules/media/media.info
index 2d146f35..27a92be0 100644
--- a/drupal7/sites/all/modules/media/media.info
+++ b/drupal7/sites/all/modules/media/media.info
@@ -18,14 +18,15 @@ files[] = includes/MediaEntityTranslationHandler.inc
 files[] = includes/media_views_plugin_display_media_browser.inc
 files[] = includes/media_views_plugin_style_media_browser.inc
 files[] = tests/media.test
-files[] = tests/media.entity.test
-files[] = tests/media.file.usage.test
 
 configure = admin/config/media/browser
 
-; Information added by drupal.org packaging script on 2013-10-25
-version = "7.x-2.0-alpha3"
+; We have to add a fake version so Git checkouts do not fail Media dependencies
+version = 7.x-2.x-dev
+
+; Information added by Drupal.org packaging script on 2014-10-04
+version = "7.x-2.0-alpha4"
 core = "7.x"
 project = "media"
-datestamp = "1382744872"
+datestamp = "1412422430"
 
diff --git a/drupal7/sites/all/modules/media/media.install b/drupal7/sites/all/modules/media/media.install
index 343ba7fd..43a17456 100644
--- a/drupal7/sites/all/modules/media/media.install
+++ b/drupal7/sites/all/modules/media/media.install
@@ -9,42 +9,12 @@
  * Implements hook_install().
  */
 function media_install() {
-  // Create initial display settings.
-  module_load_include('inc', 'file_entity', 'file_entity.file_api');
-  $default_image_styles = array(
-    'preview' => 'media_thumbnail',
-    'teaser' => 'medium',
-    'full' => 'large',
-  );
-  // Only needed by sites that updated from Media 1.x.
-  // @see media_entity_info_alter()
-  if (variable_get('media__show_deprecated_view_modes')) {
-    $default_image_styles['media_original'] = '';
-  }
-
-  foreach ($default_image_styles as $view_mode => $image_style) {
-    $existing_display = file_displays_load('image', $view_mode);
-
-    if (empty($existing_display)) {
-      $display_name = 'image__' . $view_mode . '__file_image';
-      $display = array(
-        'api_version' => 1,
-        'name' => $display_name,
-        'status' => 1,
-        'weight' => 5,
-        'settings' => array('image_style' => $image_style),
-        'export_type' => NULL,
-      );
-      file_display_save((object) $display);
-    }
-  }
-
   // Make sure that we set the icon base directory variable if it is not
   // already set.
-  $base = variable_get('media__icon_base_directory', NULL);
+  $base = variable_get('media_icon_base_directory', NULL);
   if (!isset($base)) {
     $default_base = 'public://media-icons';
-    variable_set('media__icon_base_directory', $default_base);
+    variable_set('media_icon_base_directory', $default_base);
   }
   try {
     _media_install_copy_icons();
@@ -58,12 +28,12 @@ function media_install() {
  * Copy the media file icons to files directory for use with image styles.
  */
 function _media_install_copy_icons() {
-  $destination = variable_get('media__icon_base_directory', 'public://media-icons') . '/' . variable_get('media__icon_set', 'default');
+  $destination = variable_get('media_icon_base_directory', 'public://media-icons') . '/' . variable_get('media_icon_set', 'default');
   if (!file_prepare_directory($destination, FILE_CREATE_DIRECTORY)) {
     throw new Exception("Unable to create directory $destination.");
   }
   // @todo If we ever add another default icon set, this should copy all images from one directory up.
-  $source = drupal_get_path('module', 'media') . '/images/icons/' . variable_get('media__icon_set', 'default');
+  $source = drupal_get_path('module', 'media') . '/images/icons/' . variable_get('media_icon_set', 'default');
   $files = file_scan_directory($source, '/.*\.(png|jpg)$/');
   foreach ($files as $file) {
     $result = file_unmanaged_copy($file->uri, $destination, FILE_EXISTS_REPLACE);
@@ -78,30 +48,23 @@ function _media_install_copy_icons() {
  */
 function media_uninstall() {
   // Remove variables.
-  variable_del('media__wysiwyg_title');
-  variable_del('media__wysiwyg_icon_title');
-  variable_del('media__wysiwyg_default_view_mode');
-  variable_del('media__wysiwyg_upload_directory');
-  variable_del('media__wysiwyg_allowed_types');
-  variable_del('media__wysiwyg_allowed_attributes');
-  variable_del('media__wysiwyg_browser_plugins');
-  variable_del('media__dialog_theme');
-  variable_del('media__max_filesize');
-  variable_del('media__debug');
-  variable_del('media__file_list_size');
-  variable_del('media__xml_cache_expire');
-  variable_del('media__import_batch_size');
-  variable_del('media__fromurl_supported_schemes');
-  variable_del('media__icon_base_directory');
-  variable_del('media__icon_set');
-  variable_del('media__show_deprecated_view_modes');
-  variable_del('media__show_file_type_rebuild_nag');
-  variable_del('media__field_select_media_text');
-  variable_del('media__field_remove_media_text');
-  variable_del('media__browser_library_empty_message');
-  variable_del('media__browser_pager_limit');
-  variable_del('media__browser_viewtype_default');
-  variable_del('media__display_types_migration_mess');
+  variable_del('media_dialog_theme');
+  variable_del('media_icon_base_directory');
+  variable_del('media_icon_set');
+  variable_del('media_show_deprecated_view_modes');
+
+  // Dialog options.
+  variable_del('media_dialogclass');
+  variable_del('media_modal');
+  variable_del('media_draggable');
+  variable_del('media_resizable');
+  variable_del('media_minwidth');
+  variable_del('media_width');
+  variable_del('media_height');
+  variable_del('media_position');
+  variable_del('media_zindex');
+  variable_del('media_backgroundcolor');
+  variable_del('media_opacity');
 }
 
 /**
@@ -129,6 +92,9 @@ function media_update_dependencies() {
   $dependencies['media'][7208] = array(
     'file_entity' => 7210,
   );
+  $dependencies['media'][7212] = array(
+    'file_entity' => 7210,
+  );
   return $dependencies;
 }
 
@@ -916,12 +882,15 @@ function media_update_7208() {
 }
 
 /**
- * DEPRECATED: Update {file_managed}.type with the new file types provided by
- * file_entity. (Types migration has been moved to admin/structure/file-types/upgrade',
- * where can be executed manually.)
+ * Enable the hidden media_migrate_file_types module to provide a UI to update
+ * {file_managed}.type with the new file types provided by file_entity.
  */
 function media_update_7209() {
+  drupal_load('module', 'media_migrate_file_types');
 
+  if (_media_migrate_file_types_get_migratable_file_types()) {
+    module_enable(array('media_migrate_file_types'));
+  }
 }
 
 /**
@@ -932,31 +901,43 @@ function media_update_7210() {
 }
 
 /**
- * Flush old version of the image style to make the thumbnails appear correctly.
+ * Save a square_thumbnail image style in the database for legacy support if one
+ * does not already exist.
  */
 function media_update_7211() {
-  $style = image_style_load('square_thumbnail');
+  $default_style = array(
+    'name' => 'square_thumbnail'
+  );
 
-  if ($style) {
-    $style['name'] = 'media_thumbnail';
-    image_style_save($style);
-  }
+  // Clear the image cache to remove any old image styles that only exist in
+  // code.
+  cache_clear_all('*', 'cache_image', TRUE);
+
+  // Check if the square_thumbnail image style exists.
+  // The style will only exist if the user has customized it, otherwise it would
+  // have been removed by clearing the image style cache.
+  $existing_style = image_style_load('square_thumbnail');
+
+  // Save a square_thumbnail image style in the database for legacy support.
+  // This is only necessary if a square_thumbnail image style doesn't already
+  // exist.
+  if (empty($existing_style)) {
+    $style = image_style_save($default_style);
+
+    $effect = array(
+      'name' => 'image_scale_and_crop',
+      'data' => array(
+        'width' => 180,
+        'height' => 180,
+        'weight' => 0,
+      ),
+      'isid' => $style['isid'],
+    );
 
-  // Replace any instances in display settings
-  module_load_include('inc', 'file_entity', 'file_entity.file_api');
-  $entity_info = entity_get_info('file');
-  $view_modes = array('default' => array('label' => t('Default'))) + $entity_info['view modes'];
-  foreach ($view_modes as $view_mode => $view_mode_info) {
-    $displays = file_displays_load('image', $view_mode);
-    foreach ($displays as $display) {
-      if ($display->settings['image_style'] == 'square_thumbnail') {
-        $display->settings['image_style'] = 'media_thumbnail';
-        file_display_save($display);
-      }
-    }
+    image_effect_save($effect);
   }
 
-  return t('Flushed image style and updated display styles.');
+  return t('Saved a square_thumbnail image style in the database for legacy support if one did not already exist.');
 }
 
 /**
@@ -1068,3 +1049,125 @@ function media_update_7218() {
 
   variable_del('media__xml_cache_expire');
 }
+
+/**
+ * Enable the Media WYSIWYG submodule.
+ */
+function media_update_7219() {
+  if (module_exists('wysiwyg')) {
+    module_enable(array('media_wysiwyg'));
+  }
+}
+
+/**
+ * Delete the deprecated media__file_list_size variable.
+ */
+function media_update_7220() {
+  variable_del('media__file_list_size');
+}
+
+/**
+ * Enable the Media Bulk Upload submodule.
+ */
+function media_update_7221() {
+  if (module_exists('multiform') && module_exists('plupload')) {
+    module_enable(array('media_bulk_upload'));
+  }
+}
+
+/**
+ * Delete the deprecated media__display_types_migration_mess variable.
+ */
+function media_update_7222() {
+  variable_del('media__display_types_migration_mess');
+}
+
+/**
+ * Delete legacy variables.
+ */
+function media_update_7223() {
+  variable_del('media__max_filesize');
+  variable_del('media__debug');
+  variable_del('media__xml_cache_expire');
+  variable_del('media__show_file_type_rebuild_nag');
+  variable_del('media__field_select_media_text');
+  variable_del('media__field_remove_media_text');
+  variable_del('media__browser_library_empty_message');
+  variable_del('media__browser_pager_limit');
+  variable_del('media__browser_viewtype_default');
+}
+
+/**
+ * Rename variables, removing variable namespace.
+ */
+function media_update_7224() {
+  // Create an array of variables sans 'media' prefix.
+  $variables = array('wysiwyg_title', 'wysiwyg_icon_title', 'wysiwyg_default_view_mode', 'wysiwyg_upload_directory', 'wysiwyg_allowed_types', 'wysiwyg_allowed_attributes', 'wysiwyg_browser_plugins', 'dialog_theme', 'import_batch_size', 'fromurl_supported_schemes', 'icon_base_directory', 'icon_set', 'show_deprecated_view_modes');
+
+  foreach ($variables as $variable) {
+    // Find the value of the old variable.
+    $value = variable_get('media__' . $variable);
+
+    // Port the value of the variable if it was set.
+    if (!is_null($value)) {
+      variable_set('media_' . $variable, $value);
+    }
+
+    // Remove the old variable.
+    variable_del('media__' . $variable);
+  }
+}
+
+/**
+ * Migrate variables to appropriate submodules.
+ */
+function media_update_7225() {
+  $data = array(
+    'media_wysiwyg' => array(
+      'wysiwyg_title',
+      'wysiwyg_icon_title',
+      'wysiwyg_default_view_mode',
+      'wysiwyg_upload_directory',
+      'wysiwyg_allowed_types',
+      'wysiwyg_allowed_attributes',
+      'wysiwyg_browser_plugins',
+    ),
+    'media_internet' => array(
+      'fromurl_supported_schemes',
+    ),
+    'media_bulk_upload' => array(
+      'import_batch_size',
+    ),
+  );
+
+  foreach ($data as $module => $variables) {
+    foreach ($variables as $variable) {
+      // Only port variables to submodules if the submodule exists.
+      if (module_exists($module)) {
+        // Find the value of the old variable.
+        $value = variable_get('media_' . $variable);
+
+        // Port the value of the variable if it was set.
+        if (!is_null($value)) {
+          variable_set($module . '_' . $variable, $value);
+        }
+      }
+
+      // Remove the old variable.
+      variable_del('media_' . $variable);
+    }
+  }
+}
+
+/**
+ * Accommodate the introduction of a new permission which restricts access to
+ * the media browser by granting it to existing users who were able to access
+ * it.
+ */
+function media_update_7226() {
+  $roles = user_roles(FALSE, 'create files');
+
+  foreach ($roles as $rid => $role) {
+    user_role_grant_permissions($rid, array('access media browser'));
+  }
+}
diff --git a/drupal7/sites/all/modules/media/media.media.inc b/drupal7/sites/all/modules/media/media.media.inc
index 4a20dee0..2700265f 100644
--- a/drupal7/sites/all/modules/media/media.media.inc
+++ b/drupal7/sites/all/modules/media/media.media.inc
@@ -40,97 +40,71 @@ function media_media_browser_plugin_info() {
 }
 
 /**
- * Implements hook_query_media_browser_alter().
+ * Implements hook_query_TAG_alter().
+ *
+ * @todo: Potentially move this into media.module in a future version of Media.
  */
 function media_query_media_browser_alter($query) {
   // Ensure that the query is against the file_managed table.
   $tables = $query->getTables();
+
   if (empty($tables['file_managed'])) {
     throw new Exception(t('Media browser being queried without the file_managed table.'));
   }
+
   $alias = $tables['file_managed']['alias'];
 
-  $params = drupal_get_query_parameters();
   // How do we validate these?  I don't know.
   // I think PDO should protect them, but I'm not 100% certain.
-  array_walk_recursive($params, 'media_recursive_check_plain');
-
-  $types = !empty($params['types']) ? $params['types'] : NULL;
-  $url_include_patterns = !empty($params['url_include_patterns']) ? $params['url_include_patterns'] : NULL;
-  $url_exclude_patterns = !empty($params['url_exclude_patterns']) ? $params['url_exclude_patterns'] : NULL;
-  $allowed_schemes = !empty($params['schemes']) ? array_filter($params['schemes']) : array();
-  $extensions = !empty($params['file_extensions']) ? array_filter(explode(' ', $params['file_extensions'])) : array();
-
-  $or_condition = db_or();
-
-  if (!empty($allowed_schemes)) {
-    // Include local files with the allowed extensions and types.
-    $local_wrappers = array_intersect_key(media_get_local_stream_wrappers(), $allowed_schemes);
-    if (!empty($extensions) && !empty($local_wrappers)) {
-      // Extension filtering.
-      $local_condition = db_or();
-      foreach (array_keys($local_wrappers) as $scheme) {
+  $params = media_get_browser_params();
+
+  // Gather any file restrictions.
+  $types = !empty($params['types']) ? $params['types'] : array();
+  $schemes = !empty($params['schemes']) ? $params['schemes'] : array();
+  $extensions = !empty($params['file_extensions']) ? explode(' ', $params['file_extensions']) : array();
+
+  $or = db_or();
+
+  // Filter out files with restricted types.
+  if (!empty($types)) {
+    $query->condition($alias . '.type', $types, 'IN');
+  }
+
+  // Filter out files with restricted schemes.
+  if (!empty($schemes)) {
+    $local_or = db_or();
+    $local_and = db_and();
+
+    // Gather all of the local stream wrappers.
+    $local_stream_wrappers = media_get_local_stream_wrappers();
+
+    foreach ($schemes as $scheme) {
+      // Only local files have extensions.
+      // Filter out files with restricted extensions.
+      if (!empty($extensions) && isset($local_stream_wrappers[$scheme])) {
+        $mimetypes = array();
         foreach ($extensions as $extension) {
-          $local_condition->condition($alias . '.uri', db_like($scheme . '://') . '%' . db_like('.' . $extension), 'LIKE');
+          $mimetype = media_get_extension_mimetype($extension);
+          if ($mimetype) {
+            $mimetypes[] = $mimetype;
+          }
         }
+        $local_and->condition($alias . '.uri', db_like($scheme . '://') . '%', 'LIKE');
+        if (count($mimetypes)) {
+          $local_and->condition($alias . '.filemime', $mimetypes, 'IN');
+        }
+        $local_or->condition($local_and);
+        $local_and = db_and();
       }
-      $or_condition->condition($local_condition);
-    }
-    if (!empty($types) && !empty($local_wrappers)) {
-      // Type filtering.
-      $local_condition = db_or();
-      foreach (array_keys($local_wrappers) as $scheme) {
-        $local_condition->condition($alias . '.type', $types, 'IN');
-      }
-      $or_condition->condition($local_condition);
-    }
-
-    // Include remote files with the allowed file types.
-    // We cant filter extensions here, because remote file filenames usually
-    // are a url or a parameter of a query.
-    $remote_wrappers = array_intersect_key(media_get_remote_stream_wrappers(), $allowed_schemes);
-    if (!empty($types) && !empty($remote_wrappers)) {
-      $remote_condition = db_and();
-      $wrapper_condition = db_or();
-      foreach (array_keys($remote_wrappers) as $scheme) {
-        $wrapper_condition->condition($alias . '.uri', db_like($scheme . '://') . '%', 'LIKE');
-      }
-      $remote_condition->condition($wrapper_condition);
-      $remote_condition->condition($alias . '.type', $types, 'IN');
-      $or_condition->condition($remote_condition);
-    }
-  }
-  else {
-    if (!empty($types)) {
-      $query->condition($alias . '.type', $types, 'IN');
-    }
-    if (!empty($extensions)) {
-      foreach ($extensions as $extension) {
-        $or_condition->condition($alias . '.uri', db_like('.' . $extension), 'LIKE');
+      else {
+        $local_or->condition($alias . '.uri', db_like($scheme . '://') . '%', 'LIKE');
       }
     }
-  }
 
-  if ($or_condition->count()) {
-    $query->condition($or_condition);
+    $or->condition($local_or);
   }
 
-  if ($url_include_patterns) {
-    $query->condition($alias . '.uri', '%' . db_like($url_include_patterns) . '%', 'LIKE');
-    // Insert stream related restrictions here.
-  }
-  if ($url_exclude_patterns) {
-    $query->condition($alias . '.uri', '%' . db_like($url_exclude_patterns) . '%', 'NOT LIKE');
-  }
-
-  if (!user_access('administer files')) {
-    $query->condition($alias . '.uri', db_like('private://') . '%', 'NOT LIKE');
-  }
-
-  // @todo This is possibly redundant since it's already filtered in the view.
-  $query->condition($alias . '.status', FILE_STATUS_PERMANENT);
-
-  foreach (array_keys(file_entity_get_hidden_stream_wrappers()) as $name) {
-    $query->condition($alias . '.uri', db_like($name . '://') . '%', 'NOT LIKE');
+  if ($or->count()) {
+    $query->condition($or);
   }
 }
